#include <RP2040_SD.h>

void DateTimeCallbackSD(uint16_t* date, uint16_t* time)
{
  BerechneGlobalzeit(-1,0);
  *date = FAT_DATE(Jhr+2000,Monat,Tag); 
  *time = FAT_TIME(GlobalZeit.Tm.tm_hour,GlobalZeit.Tm.tm_min,GlobalZeit.Tm.tm_sec);
}

void OpenSD()
{
  if (SD.begin(SD_CS_PIN)) // CS_PIN mu natrlichangegeben sein
  {
    RP2040_SdFile::dateTimeCallback(DateTimeCallbackSD); 
  }
}

void LiesDirSD()
{
  File Dir = SD.open("/");
  
  uint32_t Len;
  time_t DatZeit;
  uint16_t i = 1;
  while(1)
  {
    File entry = Dir.openNextFile();
    if (!entry) break; // no more files
    DatZeit = 0;
    if (entry.isDirectory() ) Len = 0; else
    {
       DatZeit = entry.getLastWrite();      
       Len = entry.size(); i++;
    }
    // BerechneZeit berechnet aus der Unix-Zeit ber localtime_r die entsprechen Zeitwerte Tag, ..
    // Print("%2d: %16s %8u %s\r\n",i,entry.name(),Len,BerechneZeit(DatZeit));
    entry.close();
  }
  return i;
}
